package javasamp;

import java.awt.*;
import java.util.*;
import java.util.Vector;

import qvs.*;
import qvs.RPAMEventListener;
import qvs.RPAMEvents.*;
import qvs.RPAMDevices.*;

import qvs.RPAMApp;
import qvs.RPAMTerminal;
import qvs.RPAMDevices.POSDisplay;
import java.awt.event.*;
import javax.swing.*;

public class MainForm extends JDialog implements qvs.RPAMGlobals,
                                             POSKybdListener, RPAMEventListener,
                                             VDisplayEventListener
   {
   RPAMTerminal Term;
   RPAMApp App;
   Integer TermNum;
   Integer UnitID;
   Integer StoreNum;
   SerialEventHandler Serial1Handler;  /* an instance of the SerialEvent     */
   SerialEventHandler Serial2Handler;  /* an instance of the SerialEvent     */
   static int FirstVDispEventReceived = 0;
   int m_EnableVDisplay=0;
   int m_UseGSAKeymap=0;
   int m_AutoConnectEnabled=0;
   int AppHardTotals=0;
   byte [] totals;

   JTextField Row1;
   JTextField Row2;
   JTextField UnitEdit;
   JTextField TermEdit;
   JLabel UnitLabel;
   JLabel TermLabel;
   JCheckBox  Connect;
   JCheckBox  MgrKey;
   JButton StartBtn;
   POSKybd Keyboard;

   JScrollPane ScrlPane;
   JList Receipt;
   DefaultListModel ReceiptModel;
   String CodeString = "";

   JCheckBox  UseGSAKeymap;
   JCheckBox  EnableVDisplay;
   JPanel jPanel1 = new JPanel();
   JCheckBox  CodeMode;
   JCheckBox  DIDocPresent;

   public MainForm()
      {
      Init("","", 0, 0, 0, 0);
      }

   public MainForm(String TermNum, String StoreNum, int pEnableVDisplay, int pUseGSAKeymap, int pAutoConnectEnabled, int AppHardTotals)
      {
      Init(TermNum, StoreNum, pEnableVDisplay, pUseGSAKeymap, pAutoConnectEnabled, AppHardTotals);
      }

   public String ByteArrToString(byte[] arr, int start, int len)
      {
      String RetVal = "";
      int i;
      for (i=start;i<start+len;i++)
         {
         RetVal = RetVal + (char)arr[i];
         }
      return RetVal;
      }

   public byte[] StringToByteArr(String str)
      {
      int Len = str.length();
      byte[] RetVal = new byte[Len];
      int i;
      for (i=0;i<Len;i++)
         {
         RetVal[i] = (byte)(str.charAt(i));
         }
      return RetVal;

      }

    public void Init(String TermNum, String StoreNum, int pEnableVDisplay, int pUseGSAKeymap, int pAutoConnectEnabled, int AppHardTotals)
      {
      int ANDHeight = 23;
      int ANDWidth = 285;
      int ANDX = 5;
      int ANDY = 50;
      int x;

      if (TermNum.length() == 0)
         {
         TermNum = "1";
         }

      if (StoreNum.length() == 0)
         {
         StoreNum = "0";
         }

      this.TermNum = new Integer(TermNum);
      this.StoreNum = new Integer(StoreNum);
      this.UnitID = new Integer(1);
      m_EnableVDisplay = pEnableVDisplay;
      m_UseGSAKeymap = pUseGSAKeymap;
      m_AutoConnectEnabled = pAutoConnectEnabled;
      this.AppHardTotals = AppHardTotals;

      Serial1Handler = new SerialEventHandler(1);
      Serial2Handler = new SerialEventHandler(2);

      try
         {
         jbInit();
         }
      catch(Exception e)
         {
         e.printStackTrace();
         }

      setBounds(100,100,350,520);
      this.setTitle("TC Java Socket Client");
      getContentPane().setLayout(null);

      Row1 = new JTextField();
      getContentPane().add(Row1);
      Row1.setBounds(ANDX,ANDY,ANDWidth,ANDHeight);
      Row1.setBorder(null);
      Row1.setBackground(Color.black);
      Row1.setForeground(Color.green);
      Row1.setFont(new Font("Monospaced", Font.BOLD, 21));

      Row2 = new JTextField();
      getContentPane().add(Row2);
      Row2.setBounds(ANDX,ANDY+ANDHeight,ANDWidth,ANDHeight);
      Row2.setBorder(null);
      Row2.setBackground(Color.black);
      Row2.setForeground(Color.green);
      Row2.setFont(new Font("Monospaced", Font.BOLD, 21));

      UnitLabel = new JLabel();
      getContentPane().add(UnitLabel);
      UnitLabel.setBounds(ANDX, ANDX, 20, 25);
      UnitLabel.setText("ID");
      UnitLabel.setDisplayedMnemonic('I');
      UnitLabel.setForeground(Color.black);

      UnitEdit = new JTextField();
      getContentPane().add(UnitEdit);
      UnitEdit.setBounds(ANDX+20,ANDX,40,25);
      UnitEdit.setBorder(BorderFactory.createLoweredBevelBorder());
      UnitEdit.setText(this.UnitID.toString());
      UnitEdit.setFocusAccelerator('I');

      TermLabel = new JLabel();
      getContentPane().add(TermLabel);
      TermLabel.setBounds(ANDX+20+40+10, ANDX, 40, 25);
      TermLabel.setText("Term");
      TermLabel.setDisplayedMnemonic('M');
      TermLabel.setForeground(Color.black);

      TermEdit = new JTextField();
      getContentPane().add(TermEdit);
      TermEdit.setBounds(ANDX+20+40+10+40,ANDX,40,25);
      TermEdit.setBorder(BorderFactory.createLoweredBevelBorder());
      getContentPane().add(TermEdit);
      TermEdit.setText(this.TermNum.toString());
      TermEdit.setFocusAccelerator('M');

      Connect = new JCheckBox();
      getContentPane().add(Connect);
      Connect.setBounds(ANDX+20+40+10+40+10+40, ANDX-5, 65, 25);
      Connect.setText("Connect");
      Connect.setMnemonic('N');

      MgrKey = new JCheckBox();
      getContentPane().add(MgrKey);
      MgrKey.setBounds(ANDX+20+40+10+40+10+40, ANDX+15, 65, 25);
      MgrKey.setText("MgrKey");
      MgrKey.setMnemonic('K');
      MgrKey.addActionListener(new ActionListener()
         {
         public void actionPerformed(ActionEvent e)
            {
            MgrKeyButtonPressed();
            }
         });

      StartBtn = new JButton();
      getContentPane().add(StartBtn);
      StartBtn.setBounds(ANDX+20+40+10+40+10+40+10+65, ANDX, 95, 35);
      StartBtn.setBorder(BorderFactory.createRaisedBevelBorder());
      StartBtn.setText("Start Term");
      StartBtn.addActionListener(new ActionListener()
         {
         public void actionPerformed(ActionEvent e)
            {
            StartButtonPressed();
            }
         });
      StartBtn.setMnemonic('A');

      Keyboard = new POSKybd();
      Keyboard.addPOSKybdListener(this);
      getContentPane().add(Keyboard);

      ScrlPane = new JScrollPane();
      ScrlPane.setLayout(null);
      ScrlPane.setBorder(null);
      ScrlPane.setBounds(5, 275, 330, 165);

      Receipt = new JList();

      ReceiptModel = new DefaultListModel();
      ReceiptModel.ensureCapacity(1000);
      Receipt.setModel(ReceiptModel);
      Receipt.setFont(new java.awt.Font("Monospaced", 1, 14));
      Receipt.setFixedCellHeight(25);
      Receipt.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

      ScrlPane.getViewport().add(Receipt);
      ScrlPane.getViewport().setBounds(0, 0, 330, 165);
      ScrlPane.getViewport().setView(Receipt);
      ScrlPane.getViewport().setVisible(true);
      Receipt.setVisible(true);
      ScrlPane.setVisible(true);

      Receipt.setSelectedIndex(ReceiptModel.size()-1);
      Receipt.ensureIndexIsVisible(ReceiptModel.size()-1);
      getContentPane().add(ScrlPane);

      UseGSAKeymap = new JCheckBox();
      getContentPane().add(UseGSAKeymap);
      UseGSAKeymap.setBounds(5, 445, 120, 25);
      UseGSAKeymap.setText("Use GSA Keymap");
      UseGSAKeymap.setMnemonic('U');
      if (m_UseGSAKeymap == 1)
         {
         UseGSAKeymap.getModel().setSelected(true);
         Keyboard.UseGSAKeymap();
         }

      UseGSAKeymap.addActionListener(new ActionListener()
         {
         public void actionPerformed(ActionEvent e)
            {
            if (UseGSAKeymap.getModel().isSelected())
               {
               Keyboard.UseGSAKeymap();
               }
            else
               {
               Keyboard.UseSAKeymap();
               }
            }
         });

      DIDocPresent = new JCheckBox();
      getContentPane().add(DIDocPresent);
      DIDocPresent.setBounds(5, 465, 120, 25);
      DIDocPresent.setText("DI Doc Present");
      DIDocPresent.setMnemonic('P');

      DIDocPresent.addActionListener(new ActionListener()
         {
         public void actionPerformed(ActionEvent e)
            {
            if (DIDocPresent.getModel().isSelected())
               {
               Term.getPrinter().putDIDocPresent(true);
               }
            else
               {
               Term.getPrinter().putDIDocPresent(false);
               }
            }
         });

      EnableVDisplay = new JCheckBox();
      getContentPane().add(EnableVDisplay);
      EnableVDisplay.setBounds(225, 445, 165, 25);
      EnableVDisplay.setText("Enable VDisplay");
      EnableVDisplay.setMnemonic('V');
      if (m_EnableVDisplay == 1)
         {
         EnableVDisplay.getModel().setSelected(true);
         }

      CodeMode = new JCheckBox();
      getContentPane().add(CodeMode);
      CodeMode.setBounds(135, 445, 80, 25);
      CodeMode.setText("CodeMode");
      CodeMode.setMnemonic('V');
      CodeMode.addActionListener(new ActionListener()
         {
         public void actionPerformed(ActionEvent e)
            {
            if (CodeMode.getModel().isSelected())
               {
               Keyboard.gCodeMode = 1;
               }
            else
               {
               Keyboard.gCodeMode = 0;
               }
            }
         });

      Term = new RPAMTerminal();
      Term.addRPAMEventListener(this);

      App = new RPAMApp();
      if (m_AutoConnectEnabled == 1)
         {
         Connect.getModel().setSelected(true);
         StartButtonPressed();
         }
      totals = new byte[50000];

      for (x=0;x<50000;x++)
         {
         totals[x] = (byte)0;
         }
      }

   public void DoFileOp()
      {
      POSFile PFile;
      POSKeyedFile PKFile;
      PFile = new POSFile();
      PKFile = new POSKeyedFile();
      int x;
      int y;
      int BytesRead=0;
      int CumBytesRead;
      int Offset;
      byte[] buf = new byte[25];
      int rc;


      PFile.setUnitID(1);
      PFile.setName("R::ADX_UDT1\\FILEOP.DAT");


      // create the file with read/write/delete permissions
      PFile.Create(rpaFlgDelete + rpaFlgWrite + rpaFlgRead   , 0x400, 0, 0);

      if (PFile.getErrorCode4690() == 0)
         {
         // now write some data to the file

         for (x=0;x<20;x++)
            {
            for (y=0;y<25;y++)
              buf[y] = (byte)(x + 0x30);

            PFile.Write(rpaSeekFP, buf, 25, 0);

            }
            // close the file
            PFile.Close();
         }
      else
         {
         System.out.println("Create of FILEOP.DAT failed " +
                                                    PFile.getErrorCode4690());
         }

         // now read in a couple of buffers from the file
         PFile.Open(rpaFlgRead, 0);
         if (PFile.getErrorCode4690() == 0)
            {
            // read 25 bytes from offset 35
            BytesRead = PFile.Read(rpaSeekBOF, buf, 25, 35);

            // read 12 bytes from offset 47
            BytesRead = PFile.Read(rpaSeekBOF, buf, 12, 47);

            // now read sequentially through the file
            BytesRead = 1;
            CumBytesRead = 0;
            Offset = 0;
            while (BytesRead > 0)
               {
               BytesRead = PFile.Read(rpaSeekBOF, buf, 24, Offset);
               if (BytesRead == 0)
                  {
                  System.out.println("EOF found, cumulative bytes read " +
                                                                 CumBytesRead);
                  System.out.println("ErrCode  " + PFile.getErrorCode4690());
                  }
               else if (BytesRead <0)
                  {
                  System.out.println("4690 error " + PFile.getErrorCode4690());
                  }
               else
                  {
                  CumBytesRead = CumBytesRead + BytesRead;
                  Offset = Offset + BytesRead;
                  }
               }
            // close the file
            PFile.Close();
            }

      // now do some keyed file ops
      // set the unit ID and name
      // unit ID must match unit ID of the terminal you want to
      // use
      PKFile.setUnitID(1);
      PKFile.setName("R::ADX_UDT1\\KEYED.FIL");

      // open the file with read/write permissions
      PKFile.Open(rpaFlgWrite + rpaFlgRead , 0);
      if (PKFile.getErrorCode4690() == 0)
         {
         // write a record with key value 'KEY02' to the file
         // the sample keyed file 'KEYED.FIL' has record length
         // of 20 with a key length of 5
         buf = StringToByteArr("KEY02X_____________Y");
         rc = PKFile.Write(0, buf, 20);
         buf = StringToByteArr("KEY98XjjfjjfjjfjjfjY");
         rc = PKFile.Write(0, buf, 20);
         buf = StringToByteArr("KEY99X9_9_9_9_9_9_9Y");
         rc = PKFile.Write(0, buf, 20);
         buf = StringToByteArr("KEY9AX9a9a9a9a9a9a9Y");
         rc = PKFile.Write(0, buf, 20);

         // put the key value to read in the buffer
         buf = StringToByteArr("                    ");
         buf = StringToByteArr("KEY02               ");

         // read the data
         rc = PKFile.Read(0, buf, 20, 5);

         // delete some records
         buf = StringToByteArr("KEY01");
         rc = PKFile.DeleteRecord(buf, 5);
         buf = StringToByteArr("KEY98");
         rc = PKFile.DeleteRecord(buf, 5);

         // close the file
         PKFile.Close(0);
         }
      }

   public void MgrKeyButtonPressed()
      {
      int keypos = (MgrKey.getModel().isSelected()) ? 1 : 0;
      Term.getKeyboard().setKeylockPosition(keypos);
      System.out.println("Mgr key " + keypos);
      }

   public void StartButtonPressed()
      {
      App.setTracing(1);
      App.setTermNumAssignMode(rpaAppTermNum);
      /* App.setStartingTermNum(9); */
      UnitID = Integer.valueOf(UnitEdit.getText());
      Term.setUnitID(UnitID.intValue());
      //Term.getPrinter().setDeviceID(rpaMod34prt);
//      Term.getPrinter().setDeviceID(rpa4610prt);
//      Term.getPrinter().putMICRAttached(true);
      Row1.setText("Waiting For");
      Row2.setText("Online Event");
      App.setOptimizeDisplay(0);
      App.setStoreNum(StoreNum.intValue());   /* TESTING purposes only       */
/*
      Term.getSerial1().setDeviceEnabled();
      Term.getSerial2().setDeviceEnabled();
*/
      if (AppHardTotals != 0)
         {
         Term.getHardTotals().setDeviceResponseMode(rpaAppDeviceResponse);
         }

      Term.getSerial1().addSerialEventListener(Serial1Handler);
      Term.getSerial2().addSerialEventListener(Serial2Handler);
      Term.getVDisplay().addVDisplayEventListener(this);

      Term.getScale().Enable();

/* Enable the VDISPLAY device if asked to do so. */
      if (EnableVDisplay.getModel().isSelected())
         {
         POSVDisplay vd = Term.getVDisplay();
         Term.getVDisplay().setDeviceEnabled();

         /*
         This just shows that the properties of the VDISPLAY object
         are invalid until the first CursorVisibilityChangeEvent
         is received
         */

         /*
         System.out.println("fmt: " + vd.DisplayFormat);
         System.out.println("cur: " + vd.CursorVisible);
         System.out.println("undl: " + vd.VGAUnderlining);
         System.out.println("intens: " + vd.VGAIntensifyBackground);
         System.out.println("attrtype: " + vd.AttributeType);
         System.out.println("curr attr: " + vd.CurrentAttribute);
         System.out.println("disptype: " + vd.DisplayType);
         */
         }

      if (Connect.getModel().isSelected())
         {
         if (AppHardTotals != 0)
            {
            Term.setTermNum(0);
            TermEdit.setText("0");
            }
         else
            {
            Term.setTermNum(Integer.valueOf(TermEdit.getText()).intValue());
            }
         Term.Connect();
         }
      else
         {
         Row1.setText(Term.getANDisplay().getRow1Text());
         Row2.setText(Term.getANDisplay().getRow2Text());
         }
      }

   /*
   Called by the POSKybd class when a button is pressed
   */
   public void ButtonPressed(POSKybdButtonPressedEvent evt)
      {
      if (evt.FCode == 900)
         {
         DoFileOp();
         }
      else
         {
         Term.getKeyboard().SendKeyboardData(evt.FCode);
         }
      }

   private void jbInit() throws Exception
      {
      this.addWindowListener(new java.awt.event.WindowAdapter() {
         public void windowClosing(WindowEvent e) {
            this_windowClosing(e);
         }
      });
      this.getContentPane().add(jPanel1, BorderLayout.CENTER);
      }

   void this_windowClosing(WindowEvent e)
      {
      System.exit(0);
      }

   /* RPAM Event handlers */
   public void Offline(OfflineEvent evt) {};
   public void ConnectTimeout(ConnectTimeoutEvent evt) {};
   public void Display(DisplayEvent evt) {};
   public void Print(PrintEvent evt) {};
   public void IOProcWait(IOProcWaitEvent evt) {};
   public void PrintEx(PrintExEvent evt)
      {
      if (evt.Station == CR)
         {
         if (evt.Command == CMD_PRINT_DATA)
            {
            /* regular print data */
            ReceiptModel.addElement(ByteArrayToString(evt.Data, 0, evt.DataLen));
            Receipt.setSelectedIndex(ReceiptModel.size()-1);
            Receipt.ensureIndexIsVisible(ReceiptModel.size()-1);
            }
         else if (evt.Command == PARS46_CMDCODE_PRINT_LF)
            {
            /* line feed command, add blank line */
            ReceiptModel.addElement("");
            }
         }
      };

   public void ActivateMICR(ActivateMICREvent evt)
      {
      System.out.println("Micr activated");
      Term.getPrinter().SendMICRData("T461004610T123456789A", 0);
      };

   public void Lock(LockEvent evt) {};
   public void Unlock(UnlockEvent evt) {};
   public void ScannerUnlock(ScannerUnlockEvent evt) {};
   public void ScannerLock(ScannerLockEvent evt) {};
   public void Online(OnlineEvent evt)
      {
      Row1.setText("Terminal Online");
      Row2.setText("");
      };

   public void DisplayEx(DisplayExEvent evt)
      {
      if (evt.Device == 0)
         {
         Row1.setText(Term.getANDisplay().getRow1Text());
         Row2.setText(Term.getANDisplay().getRow2Text());
         }
      };

   public void WaitLight(WaitLightEvent evt) {};
   public void MessageLight(MessageLightEvent evt) {};
   public void OfflineLight(OfflineLightEvent evt) {};
   public void FieldLevelInput2(FieldLevelInput2Event evt) {};
   public void DrawerOpen(DrawerOpenEvent evt) {};
   public void FieldLevelInput(FieldLevelInputEvent evt) {};
   public void MsrLock(MsrLockEvent evt) {};
   public void MsrUnlock(MsrUnlockEvent evt) {};

   public void Tone(ToneEvent evt)
      {
      //System.out.println("Tone freq " + evt.Frequency + " dur " + evt.Duration);
      }

   static int call_num=0;

   public void ScaleRead(ScaleReadEvent evt)
      {
      Term.getScale().SendScaleData(0);
/*
      if (call_num == 0)
         {
         System.out.println("Sending 0 weight");
         Term.getScale().SendScaleData(0);
         }
      else
         {
         System.out.println("Sending 125 weight");
         Term.getScale().SendScaleData(125);
         }

      if (call_num == 1)
         call_num = 0;
      else
         call_num = 1;
*/
      };

   public void UserData(UserDataEvent evt)
      {
      };

   public void RunningTotalData(RunningTotalDataEvent evt) {};

   public void TotalsWrite(TotalsWriteEvent evt)
      {
      int x;
//      System.out.println("TotalsWrite Event len " + evt.Length);
      for (x=0;x<evt.Length;x++)
         {
         totals[evt.Offset+x] = evt.Data[x];
         }
      Term.getHardTotals().SendTotalsWriteResponse(evt.Length);
      };

   public void TotalsRead(TotalsReadEvent evt)
      {
      byte [] barr;
      int x;
//      System.out.println("TotalsRead Event len " + evt.Length);

      barr = new byte[evt.Length];

      for (x=0; x<evt.Length;x++)
         {
         barr[x] = totals[evt.Offset+x];
         }

      Term.getHardTotals().SendTotalsData(barr, evt.Length);
      };

   public void TermNumberChanged(TermNumberChangedEvent evt)
      {
      System.out.println("Term number has changed");
      };
   public void OfflineTotalsData(OfflineTotalsDataEvent evt) {};
   public void PrintEject(PrintEjectEvent evt) {};
   public void ReceiptCut(ReceiptCutEvent evt) {};
   public void TermIPLControl(TermIPLControlEvent evt) {};
   public void TermReload(TermReloadEvent evt) {};
   public void ActivateMarqueeDisplay(ActivateMarqueeDisplayEvent evt) {};
   public void DeactivateMarqueeDisplay(DeactivateMarqueeDisplayEvent evt) {};
   public void LoadMarqueeDisplay(LoadMarqueeDisplayEvent evt) {};

   public String ByteArrayToString(byte[] arr, int start, int len)
      {
      String RetVal = "";
      int i;
      for (i=start;i<start+len;i++)
         {
         RetVal = RetVal + (char)arr[i];
         }
      return RetVal;
      }
      class SerialEventHandler implements qvs.SerialEventListener
      {
      int Port;

      public SerialEventHandler(int pPort)
         {
         Port = pPort;
         }

      public void Open(SerialOpenEvent evt)
         {
         int GetLongVal;
         System.out.println("Serial open for port " + Port);
         System.out.println("Baud " + evt.Speed + " Parity " + evt.Parity);
         System.out.println("DBits " + evt.DataBits + " SBits " + evt.StopBits);
         System.out.println("Buffer size " + evt.BuffSize);

                                       /* send a good open return code       */
                                       /* and send a getlong status update   */
                                       /* to TC.  Note: the only bits that   */
                                       /* may be set in a getlong from the   */
                                       /* client are the ones shown here     */
         GetLongVal = s1DataLost | s2DSRActive | s2CTSActive | s2ParityError |
                                             s2FramingError | s2BreakDetected;

         if (Port == 1)
            {
            Term.getSerial1().SendOpenRc(0);
            Term.getSerial1().UpdatePortStatus(GetLongVal);
            }
         else if (Port == 2)
            {
            Term.getSerial2().SendOpenRc(0);
            Term.getSerial2().UpdatePortStatus(GetLongVal);
            }
         }

      public void PutLong(SerialPutLongEvent evt)
         {
         System.out.println( "PutLong on port " + Port + " Timeout " +
                                  evt.TimeOut + " Stat " + evt.PortStatusInfo);

                                       /* send a good  return code back to   */
                                       /* the .286                           */
         POSSerialDevice dev = (POSSerialDevice)(evt.getSource());
//         dev.SendPutLongRc((evt.TimeOut << 24) + (evt.PortStatusInfo << 16) + 0x26);
         dev.SendPutLongRc(0);
         }

      public void Write(SerialWriteEvent evt)
         {
         System.out.println("Serial write for " + evt.Length + " bytes.");
         String StrData = ByteArrToString(evt.Data,0,evt.Length);
         System.out.println("[" + StrData + "]" );

                                       /* give an rc back for the number of  */
                                       /* bytes written                      */
         POSSerialDevice dev = (POSSerialDevice)(evt.getSource());
         dev.SendWriteRc(evt.Length);

         }

      public void Close(SerialCloseEvent evt)
         {
         System.out.println("Close for port " + Port);
         }
      }


                                       /* VDISPLAY event handlers            */
   public void CursorVisibilityChange(CursorVisibilityChangeEvent evt)
      {
      POSVDisplay vd = Term.getVDisplay();
      System.out.println("CursorVisibilityChange, cursor is " + evt.CursorVisible);

      if (FirstVDispEventReceived == 0)
         {
         /*
         After the first VDISPLAY event, the properties of the
         object are available, read them now
         */

         System.out.println("fmt: " + vd.DisplayFormat);
         System.out.println("cur: " + vd.CursorVisible);
         System.out.println("undl: " + vd.VGAUnderlining);
         System.out.println("intens: " + vd.VGAIntensifyBackground);
         System.out.println("attrtype: " + vd.AttributeType);
         System.out.println("curr attr: " + vd.CurrentAttribute);
         System.out.println("disptype: " + vd.DisplayType);
         FirstVDispEventReceived = 1;
         }
      }

   public void DisplayFormatChange(DisplayFormatChangeEvent evt)
      {
      System.out.println("DisplayFormatChange, fmt is " + evt.DisplayFormat);
      }
   public void Display(VDisplayEvent evt)
      {
      System.out.println("VDisplay len " + evt.Length + " flg " + evt.Flags + " row " + evt.Row + " col " + evt.Col);
      System.out.println("[" + evt.Text + "]");
      }
   }


class POSKybdButtonPressedEvent extends EventObject
   {
   public int FCode;

   public POSKybdButtonPressedEvent(Object source, int FC)
      {
      super(source);
      FCode = FC;
      }
   }

interface POSKybdListener extends java.util.EventListener
   {
   public void ButtonPressed(POSKybdButtonPressedEvent evt);
   }


class QButton extends JButton
   {
   public int FCode;
   }

class POSKybd extends JPanel implements ActionListener
   {
   Vector Listeners = new Vector();
   QButton ButtonSlash;
   QButton Button0;
   QButton Button1;
   QButton Button2;
   QButton Button3;
   QButton Button4;
   QButton Button5;
   QButton Button6;
   QButton Button7;
   QButton Button8;
   QButton Button9;

   QButton ButtonSignon;
   QButton ButtonCash;
   QButton ButtonClear;
   QButton ButtonTotal;
   QButton ButtonEnter;
   QButton ButtonFileOp;
   public int gCodeMode=0;
   String CodeString="";

   public void actionPerformed(ActionEvent e)
      {
      int TempInt=0;
      int x;
      QButton btn = (QButton)(e.getSource());
      if (gCodeMode == 1)
         {
         if ((btn.FCode == 80 ||
             btn.FCode == 95) && (CodeString.length() > 0))
            {
            for(x=0;x<CodeString.length();x++)
               {
               TempInt = (TempInt * 10) + (int)(CodeString.charAt(x)-0x30);
       //        System.out.println("TempInt "+ TempInt);
               }

            FireEvent(TempInt);

            CodeString = "";
            }
         else if (btn.FCode >= 48 && btn.FCode <= 57)
            {
            CodeString = CodeString + (char)btn.FCode;
         //   System.out.println("CodeString " + CodeString);
            }
         }
      else
         {
         FireEvent(btn.FCode);
         }
      }

   public void UseSAKeymap()
      {
      ButtonSignon.FCode=61;
      ButtonEnter.FCode=80;
      ButtonTotal.FCode=81;
      ButtonCash.FCode=91;
      }

   public void UseGSAKeymap()
      {
      ButtonSignon.FCode=76;
      ButtonEnter.FCode=95;
      ButtonTotal.FCode=75;
      ButtonCash.FCode=69;
      }

   public POSKybd()
      {
      setLayout(null);
      setBounds(5,110,330,165);

      Button0 = new QButton();
      this.add(Button0);
      Button0.setBorder(BorderFactory.createRaisedBevelBorder());
      Button0.setBounds(0,120,80,40);
      Button0.setText("0");
      Button0.addActionListener(this);

      ButtonSlash = new QButton();
      this.add(ButtonSlash);
      ButtonSlash.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonSlash.setBounds(80,120,40,40);
      ButtonSlash.setText("/");
      ButtonSlash.addActionListener(this);

      Button1 = new QButton();
      this.add(Button1);
      Button1.setBorder(BorderFactory.createRaisedBevelBorder());
      Button1.setBounds(0,80,40,40);
      Button1.setText("1");
      Button1.addActionListener(this);

      Button2 = new QButton();
      this.add(Button2);
      Button2.setBorder(BorderFactory.createRaisedBevelBorder());
      Button2.setBounds(40,80,40,40);
      Button2.setText("2");
      Button2.addActionListener(this);

      Button3 = new QButton();
      this.add(Button3);
      Button3.setBorder(BorderFactory.createRaisedBevelBorder());
      Button3.setBounds(80,80,40,40);
      Button3.setText("3");
      Button3.addActionListener(this);

      Button4 = new QButton();
      this.add(Button4);
      Button4.setBorder(BorderFactory.createRaisedBevelBorder());
      Button4.setBounds(0,40,40,40);
      Button4.setText("4");
      Button4.addActionListener(this);

      Button5 = new QButton();
      this.add(Button5);
      Button5.setBorder(BorderFactory.createRaisedBevelBorder());
      Button5.setBounds(40,40,40,40);
      Button5.setText("5");
      Button5.addActionListener(this);

      Button6 = new QButton();
      this.add(Button6);
      Button6.setBorder(BorderFactory.createRaisedBevelBorder());
      Button6.setBounds(80,40,40,40);
      Button6.setText("6");
      Button6.addActionListener(this);

      Button7 = new QButton();
      this.add(Button7);
      Button7.setBorder(BorderFactory.createRaisedBevelBorder());
      Button7.setBounds(0,0,40,40);
      Button7.setText("7");
      Button7.addActionListener(this);

      Button8 = new QButton();
      this.add(Button8);
      Button8.setBorder(BorderFactory.createRaisedBevelBorder());
      Button8.setBounds(40,0,40,40);
      Button8.setText("8");
      Button8.addActionListener(this);

      Button9 = new QButton();
      this.add(Button9);
      Button9.setBorder(BorderFactory.createRaisedBevelBorder());
      Button9.setBounds(80,0,40,40);
      Button9.setText("9");
      Button9.addActionListener(this);

      ButtonSignon = new QButton();
      this.add(ButtonSignon);
      ButtonSignon.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonSignon.setBounds(160,0,80,40);
      ButtonSignon.setText("SignOn");
      ButtonSignon.addActionListener(this);

      ButtonCash = new QButton();
      this.add(ButtonCash);
      ButtonCash.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonCash.setBounds(240,0,80,40);
      ButtonCash.setText("Cash");
      ButtonCash.addActionListener(this);

      ButtonClear = new QButton();
      this.add(ButtonClear);
      ButtonClear.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonClear.setBounds(160,40,80,40);
      ButtonClear.setText("Clear");
      ButtonClear.addActionListener(this);

      ButtonTotal = new QButton();
      this.add(ButtonTotal);
      ButtonTotal.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonTotal.setBounds(160,80,80,40);
      ButtonTotal.setText("Total");
      ButtonTotal.addActionListener(this);

      ButtonEnter = new QButton();
      this.add(ButtonEnter);
      ButtonEnter.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonEnter.setBounds(240,40,80,80);
      ButtonEnter.setText("Enter");
      ButtonEnter.addActionListener(this);

      ButtonFileOp = new QButton();
      this.add(ButtonFileOp);
      ButtonFileOp.setBorder(BorderFactory.createRaisedBevelBorder());
      ButtonFileOp.setBounds(160,120,80,40);
      ButtonFileOp.setText("File Ops");
      ButtonFileOp.addActionListener(this);

      Button0.setMnemonic('0');
      ButtonSlash.setMnemonic('/');
      Button1.setMnemonic('1');
      Button2.setMnemonic('2');
      Button3.setMnemonic('3');
      Button4.setMnemonic('4');
      Button5.setMnemonic('5');
      Button6.setMnemonic('6');
      Button7.setMnemonic('7');
      Button8.setMnemonic('8');
      Button9.setMnemonic('9');
      ButtonSignon.setMnemonic('S');
      ButtonCash.setMnemonic('H');
      ButtonClear.setMnemonic('C');
      ButtonTotal.setMnemonic('T');
      ButtonEnter.setMnemonic('E');

      Button0.FCode=48;
      ButtonSlash.FCode=78;
      Button1.FCode=49;
      Button2.FCode=50;
      Button3.FCode=51;
      Button4.FCode=52;
      Button5.FCode=53;
      Button6.FCode=54;
      Button7.FCode=55;
      Button8.FCode=56;
      Button9.FCode=57;
      ButtonClear.FCode=73;
      ButtonFileOp.FCode = 900;
      UseSAKeymap();
      setVisible(true);
      }

   public synchronized void addPOSKybdListener(POSKybdListener listener)
      {
      if (!Listeners.contains(listener))
         {
         Listeners.addElement(listener);
         }
      }

   public synchronized void removePOSKybdListener(POSKybdListener listener)
      {
      if (Listeners.contains(listener))
         {
         Listeners.removeElement(listener);
         }
      }

   private void FireEvent(int FCode)
      {
      Vector v;

      synchronized(this)
         {
         v = (Vector) Listeners.clone();
         }

      int cnt = v.size();

      for (int i=0; i<cnt; i++)
         {
         POSKybdListener Listener = (POSKybdListener)v.elementAt(i);
         POSKybdButtonPressedEvent evt =
                                    new POSKybdButtonPressedEvent(this, FCode);
         Listener.ButtonPressed(evt);
         }
      }
   }
