! SAMPLE PROGRAM
! Test the serial comm support in RPAMFUNC/QVSRPAM
!
%ENVIRON T
! *******************  Local Variables  **************************
integer*2 serial1%, serial2%, andisp%, cashr%, hardtot%
integer*4 hx%, sx%, esum%, s%, tog%, getlongval%
integer*1 d1%, d2%, d3%
string errfx$, z$, y$, outstr$, instr$

! ****************************************************************
! ************** Write a string to the ANDISPLAY *****************
! ****************************************************************
sub writeand(wstring$, delay%) public
   string wstring$
   integer*2 delay%
   integer*2 mlen%

   mlen% = len(wstring$)
   if (mlen% < 40) then                  \
   begin
      mlen% = 40 - mlen%
      wstring$ = wstring$ + string$(mlen%, " ")
   endif

   locate #andisp%;1,1
   write #andisp%;wstring$
   if (delay% > 0) then                  \
      wait; delay%
end sub

! ****************************************************************
! ************** Write a string to the printer *******************
! ****************************************************************
sub writeprn(psta%, wstring$) public
   integer*2 psta%
   string wstring$
   integer*2 mlen%

   mlen% = len(wstring$)
   if (mlen% < 38) then                  \
   begin
      mlen% = 38 - mlen%
      wstring$ = wstring$ + string$(mlen%, " ")
   endif

   if (psta% = 2) then                   \
   begin
      write form "c38 a1";#8;wstring$
   endif                                 \
   else if (psta% = 3) then              \
   begin
      write form "c38 a1";#9;wstring$
   endif                                 \
   else                                  \
      write form "c38 a1" ;#cashr% ;wstring$

   wstring$ = ""
end sub

! ****************************************************************
! *********** Determine if pgm is running under TC ***************
! ****************************************************************
function UnderTC%
  integer UnderTC%
  integer*2 ht%

  string ErrMsg$
  string TCSignature$
  on error goto lerrhandler

  ht% = 46

  open "TOTRET:" as ht%

  ! 4690 will error out on this read, TC won't
  read form "C4"; #ht%, 1; TCSignature$
  if (TCSignature$ = "TCTC") then       \
     UnderTC% = 1                       \
  else                                  \
     UnderTC% = 0

  exit function

lerrhandler:
  UnderTC% = 0
  ErrMsg$  = "ERRN:"+str$(errn) + "ERRF:" + str$(errf%)
  call writeprn(1,ErrMsg$)

end function

! ****************************************************************
! ********************** Main Line Start *************************
! ****************************************************************
on error goto mainerr

! assign our session numbers
andisp% = 6
cashr% = 7
serial1% = 20
serial2% = 21
hardtot% = 45

! open the devices
open "ANDISPLAY:" as andisp%
call writeand("ANDISPLAY Open", 0)

open serial 1, 9600, "N", 8, 1 as serial1% buffsize 80
call writeand("Serial1 Open", 0)
!10111111
putlong serial1%, 0000FEBFH
putlong serial1%, 00002001H
close serial1%
call writeand("Serial1 Close", 0)

open serial 1, 2400, "E", 7, 0 as serial1% buffsize 90
call writeand("Serial1 Open", 0)
outstr$ = "dkdkdkdkdkdkdkdkdkdkdkdkdkdkdk"
call writeand("Serial1 Write1", 0)
write #serial1%; outstr$
d1% = 12
d2% = 34
d3% = 56
call writeand("Serial1 Write2", 0)
write #serial1%; d1%,d2%,d3%
call writeand("Send port 1 now", 0)
read  #serial1%;line instr$
call writeand(instr$,200)
call writeand("Send port 1 now", 0)
read  #serial1%;line instr$
call writeand(instr$,200)
call writeand("Send port 1 now", 0)
read  #serial1%;line instr$
call writeand(instr$,200)
close serial1%
call writeand("Serial1 Close", 0)

open serial 1, 1200, "O", 7, 1 as serial1% buffsize 33
call writeand("Serial1 Open", 0)
close serial1%
call writeand("Serial1 Close", 0)


open serial 2, 9600, "N", 8, 1 as serial2% buffsize 80
call writeand("Serial2 Open", 0)
putlong serial2%, 0000FEBFH
putlong serial2%, 00002001H
close serial2%
call writeand("Serial2 Close", 0)

open serial 2, 2400, "E", 7, 0 as serial2% buffsize 25
call writeand("Serial2 Open", 0)
close serial2%
call writeand("Serial2 Close", 0)

open serial 2, 1200, "O", 7, 1 as serial2% buffsize 33
call writeand("Serial2 Open", 0)
call writeand("Serial2 Write1", 0)
outstr$ = "1_______________________________]"
write #serial2%; outstr$
d1% = 55
d2% = 66
d3% = 77
call writeand("Serial2 Write2", 0)
write #serial2%; d1%,d2%,d3%
call writeand("Send port 2 now", 0)
read  #serial2%;line instr$
call writeand(instr$,200)
call writeand("Send port 2 now", 0)
read  #serial2%;line instr$
call writeand(instr$,200)
call writeand("Send port 2 now", 0)
read  #serial2%;line instr$
call writeand(instr$,200)
close serial2%
call writeand("Serial2 Close", 0)


call writeand("Closing Devices", 0)

close andisp%

goto exitpgm

! ****************************************************************
! *********************** Main Line End **************************
! ****************************************************************



! ****************************************************************
! *********************** Error Handler **************************
! ****************************************************************

MainErr:

hx% = errn
errfx$ = ""
for s%=28 to 0 step -4
   sx% = shift(hx%,s%)
   esum% = sx% and 000fh
   if esum% > 9 then                    \
      esum% = esum%+55                  \
   else                                 \
      esum% = esum%+48
   z$ = chr$(esum%)
   errfx$ = errfx$ + z$
next S%

z$ = err
y$ = str$(errl)
outstr$="ERR:" + z$ + " ERL:" + y$ + string$(11-len(z$)-len(y$)," ")

z$ = str$(errf%)
outstr$=outstr$ + "ERF:" + z$ + " EFX:" + errfx$ + string$(11-len(z$)-len(errfx$)," ")
call writeand(outstr$, 0)

exitpgm:
wait;3000
stop
end

